Index: src/company_gui.cpp
===================================================================
--- src/company_gui.cpp	(revision 17973)
+++ src/company_gui.cpp	(working copy)
@@ -29,7 +29,10 @@
 #include "date_func.h"
 #include "widgets/dropdown_type.h"
 #include "tilehighlight_func.h"
-
+#include "company_gui.h"
+#include "currency.h"
+#include "openttd.h"
+ 
 #include "table/strings.h"
 
 /** Company GUI constants. */
@@ -41,8 +44,9 @@
 };
 
 static void DoSelectCompanyManagerFace(Window *parent, bool show_big, int top =  FIRST_GUI_CALL, int left = FIRST_GUI_CALL);
+static void ShowCompanySharingSettings(CompanyID company);
 
-/** Standard unsorted list of expenses. */
+/** Standard unsorted list of expenses with infrastructure sharing disabled. */
 static ExpensesType _expenses_list_1[] = {
 	EXPENSES_CONSTRUCTION,
 	EXPENSES_NEW_VEHICLES,
@@ -59,7 +63,7 @@
 	EXPENSES_OTHER,
 };
 
-/** Grouped list of expenses. */
+/** Grouped list of expenses with infrastructure sharing disabled. */
 static ExpensesType _expenses_list_2[] = {
 	EXPENSES_TRAIN_INC,
 	EXPENSES_ROADVEH_INC,
@@ -79,6 +83,47 @@
 	INVALID_EXPENSES,
 };
 
+/** Standard unsorted list of expenses with infrastructure sharing enabled. */
+static ExpensesType _expenses_list_3[] = {
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	EXPENSES_LOAN_INT,
+	EXPENSES_OTHER,
+};
+
+/** Grouped list of expenses with infrastructure sharing enabled. */
+static ExpensesType _expenses_list_4[] = {
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	INVALID_EXPENSES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_LOAN_INT,
+	INVALID_EXPENSES,
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_OTHER,
+	INVALID_EXPENSES,
+};
+
 /** Expense list container. */
 struct ExpensesList {
 	const ExpensesType *et;   ///< Expenses items.
@@ -118,6 +163,8 @@
 static const ExpensesList _expenses_list_types[] = {
 	ExpensesList(_expenses_list_1, lengthof(_expenses_list_1), 0),
 	ExpensesList(_expenses_list_2, lengthof(_expenses_list_2), 3),
+	ExpensesList(_expenses_list_3, lengthof(_expenses_list_3), 0),
+	ExpensesList(_expenses_list_4, lengthof(_expenses_list_4), 3),
 };
 
 /** Widgets of the company finances windows. */
@@ -153,14 +200,12 @@
  */
 static void DrawCategories(const Rect &r)
 {
+	int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2 : _settings_client.gui.expenses_layout;
 	int y = r.top;
-
-	DrawString(r.left, r.right, y, STR_FINANCES_EXPENDITURE_INCOME_TITLE, TC_FROMSTRING, SA_CENTER, true);
 	y += FONT_HEIGHT_NORMAL + EXP_LINESPACE;
 
-	int type = _settings_client.gui.expenses_layout;
 	for (uint i = 0; i < _expenses_list_types[type].length; i++) {
-		const ExpensesType et = _expenses_list_types[type].et[i];
+		ExpensesType et = _expenses_list_types[type].et[i];
 		if (et == INVALID_EXPENSES) {
 			y += EXP_LINESPACE;
 			DrawString(r.left, r.right, y, STR_FINANCES_TOTAL_CAPTION, TC_FROMSTRING, SA_RIGHT);
@@ -207,7 +252,7 @@
 
 	Money sum = 0;
 	Money subtotal = 0;
-	int type = _settings_client.gui.expenses_layout;
+	int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2: _settings_client.gui.expenses_layout;
 	for (uint i = 0; i < _expenses_list_types[type].length; i++) {
 		const ExpensesType et = _expenses_list_types[type].et[i];
 		if (et == INVALID_EXPENSES) {
@@ -323,7 +368,7 @@
 
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *resize)
 	{
-		int type = _settings_client.gui.expenses_layout;
+		int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2: _settings_client.gui.expenses_layout;
 		switch (widget) {
 			case CFW_EXPS_CATEGORY:
 				size->width  = _expenses_list_types[type].GetCategoriesWidth();
@@ -412,8 +457,9 @@
 	virtual void OnPaint()
 	{
 		if (!small) {
+			int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2: _settings_client.gui.expenses_layout;
+			// TODO: What is this magic 26?!
 			/* Check that the expenses panel height matches the height needed for the layout. */
-			int type = _settings_client.gui.expenses_layout;
 			if (_expenses_list_types[type].GetHeight() != this->GetWidget<NWidgetCore>(CFW_EXPS_CATEGORY)->current_y) {
 				this->SetupWidgets();
 				this->ReInit();
@@ -1425,6 +1471,7 @@
 	CW_WIDGET_COMPANY_NAME,
 	CW_WIDGET_BUILD_VIEW_HQ,
 	CW_WIDGET_RELOCATE_HQ,
+	CW_WIDGET_COMPANY_SHARING,
 	CW_WIDGET_BUY_SHARE,
 	CW_WIDGET_SELL_SHARE,
 	CW_WIDGET_COMPANY_PASSWORD,
@@ -1441,6 +1488,7 @@
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   270,   359,   158,   169, STR_COMPANY_VIEW_COMPANY_NAME_BUTTON,   STR_COMPANY_VIEW_COMPANY_NAME_TOOLTIP},
 {    WWT_TEXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,    18,    29, STR_COMPANY_VIEW_VIEW_HQ_BUTTON,        STR_COMPANY_VIEW_BUILD_HQ_TOOLTIP},
 {    WWT_TEXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,    32,    43, STR_COMPANY_VIEW_RELOCATE_HQ,                        STR_COMPANY_VIEW_RELOCATE_COMPANY_HEADQUARTERS},
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,    46,    57, STR_COMPANY_VIEW_SHARING_BUTTON,        STR_COMPANY_VIEW_SHARING_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,     0,   179,   158,   169, STR_COMPANY_VIEW_BUY_SHARE_BUTTON,      STR_COMPANY_VIEW_BUY_SHARE_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   180,   359,   158,   169, STR_COMPANY_VIEW_SELL_SHARE_BUTTON,     STR_COMPANY_VIEW_SELL_SHARE_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,   138,   149, STR_COMPANY_VIEW_PASSWORD,                   STR_COMPANY_VIEW_PASSWORD_TOOLTIP},
@@ -1466,7 +1514,13 @@
 			NWidget(WWT_TEXTBTN, COLOUR_GREY, CW_WIDGET_RELOCATE_HQ), SetMinimalSize(90, 12), SetPadding(0, 4, 0, 0),
 										SetDataTip(STR_COMPANY_VIEW_RELOCATE_HQ, STR_COMPANY_VIEW_RELOCATE_COMPANY_HEADQUARTERS),
 		EndContainer(),
-		NWidget(NWID_SPACER), SetMinimalSize(0, 94),
+		NWidget(NWID_SPACER), SetMinimalSize(0, 2),
+		NWidget(NWID_HORIZONTAL),
+			NWidget(NWID_SPACER), SetFill(true, false),
+			NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, CW_WIDGET_COMPANY_SHARING), SetMinimalSize(90, 12), SetPadding(0, 4, 0, 0),
+										SetDataTip(STR_COMPANY_VIEW_SHARING_BUTTON, STR_COMPANY_VIEW_SHARING_TOOLTIP),
+		EndContainer(),
+		NWidget(NWID_SPACER), SetMinimalSize(0, 80),
 		/* Multi player buttons. */
 		NWidget(NWID_SELECTION, INVALID_COLOUR, -1),
 			NWidget(NWID_HORIZONTAL),
@@ -1601,6 +1655,7 @@
 		this->SetWidgetHiddenState(CW_WIDGET_RELOCATE_HQ,      !local || c->location_of_HQ == INVALID_TILE);
 		this->SetWidgetHiddenState(CW_WIDGET_BUY_SHARE,        local);
 		this->SetWidgetHiddenState(CW_WIDGET_SELL_SHARE,       local);
+		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_SHARING,  _settings_game.sharing.sharing_mode != SHARING_INDIVIDUAL);
 		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_PASSWORD, !local || !_networking);
 		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_JOIN,     local || !_networking);
 		this->SetWidgetDisabledState(CW_WIDGET_COMPANY_JOIN,   c->is_ai);
@@ -1717,6 +1772,10 @@
 				DoCommandP(0, this->window_number, 0, CMD_SELL_SHARE_IN_COMPANY | CMD_MSG(STR_ERROR_CAN_T_SELL_25_SHARE_IN));
 				break;
 
+			case CW_WIDGET_COMPANY_SHARING:
+				ShowCompanySharingSettings((CompanyID)this->window_number);
+				break;
+
 #ifdef ENABLE_NETWORK
 			case CW_WIDGET_COMPANY_PASSWORD:
 				if (this->window_number == _local_company) ShowNetworkCompanyPasswordWindow(this);
@@ -1880,3 +1939,492 @@
 {
 	AllocateWindowDescFront<BuyCompanyWindow>(&_buy_company_desc, company);
 }
+
+/** per-company sharing settings window */
+enum SharingSettingsWindowWidgets {
+	SSW_WIDGET_CLOSEBOX = 0,
+	SSW_WIDGET_CAPTION,
+	SSW_WIDGET_STICKY,
+	SSW_WIDGET_PANEL,
+	SSW_WIDGET_ICONS,
+	SSW_WIDGET_SETTINGS,
+	SSW_WIDGET_CURRENT,
+	SSW_WIDGET_BUTTONS,
+	SSW_WIDGET_FUTURE,
+	SSW_WIDGET_SCROLL,
+	SSW_WIDGET_OPTIONS,
+	SSW_WIDGET_COMPANIES,
+	SSW_WIDGET_RESIZE,
+};
+
+/** Window that shows per-company infrastructure sharing settings and allows changing them */
+struct SharingSettingsWindow : public Window {
+private:
+	/** order of lines in the options tab */
+	enum SharingSettingsWindowLine {
+		SSWL_HEADERS = 0,
+		SSWL_COMPANY_FIRST = 1,
+		SSWL_TRAIN_TRACK = 1,
+		SSWL_TRAIN_DEPOT,
+		SSWL_TRAIN_STATION,
+		SSWL_TRAIN_FEE,
+		SSWL_ROAD_ROADSTOP = 6,
+		SSWL_ROAD_FEE,
+		SSWL_SHIP_DOCK = 9,
+		SSWL_SHIP_FEE,
+		SSWL_PLANE_AIRPORT = 12,
+		SSWL_PLANE_FEE,
+		SSWL_END,
+	};
+
+	Company *company;                     ///< The company this window belongs to
+	CompanySharingSettingsEntry *future;  ///< future sharing settings
+	CompanySharingSettingsEntry *current; ///< current sharing settings
+
+	bool companies_tab;                   ///< Is the companies tab currently open?
+
+	VehicleType current_query_type;       ///< type of vehicle for which a querystring window is open.
+	byte clicked_row;                     ///< which of the arrow sets was clicked
+	byte clicked_side;                    ///< was the left or the right arrow clicked?
+
+	uint line_height;                     ///< Height of a single line of text + buttons
+
+	/**
+	 * Draw a string on top of a certain widget.
+	 * @param widget The widget to draw the string on.
+	 * @param y The y-coordinate to draw on.
+	 * @param string The string to draw.
+	 * @param colour TextColour to use.
+	 */
+	inline void DrawWidgetString(int widget, uint y, StringID string, TextColour colour = TC_FROMSTRING)
+	{
+		NWidgetCore *wi = this->GetWidget<NWidgetCore>(widget);
+		DrawString(wi->pos_x, wi->pos_x + wi->current_x - 1, y, string, colour);
+	}
+
+	/**
+	 * Draw the value of a boolean setting ([Not] Allowed) in the column 'current' or 'future'.
+	 * @param y The y-coordinate where the string should be drawn.
+	 * @param value The boolean value to draw (Allowed / Not allowed).
+	 * @param column_future If true, draw in the column 'future', if false, draw in the column 'current'.
+	 */
+	inline void DrawBoolValue(uint y, bool value, bool column_future)
+	{
+		this->DrawWidgetString(column_future ? SSW_WIDGET_FUTURE : SSW_WIDGET_CURRENT, y, value ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED);
+ 	}
+
+	/**
+	 * Draw a boolean sharing setting.
+	 * @param str The string to draw. (any parameters can be set beforehand)
+	 * @param y The y-coordinate where the string should be drawn. Is increased by this->line_height after drawing.
+	 * @param value_current The boolean value to draw (Allowed / Not allowed) in the column 'current'.
+	 * @param value_future The boolean value to draw (Allowed / Not allowed) in the column 'future'.
+	 */
+	void DrawSharingOption(StringID str, uint &y, bool value_current, bool value_future)
+	{
+		static const Colours _button_colour_table[2][2] = {{COLOUR_CREAM, COLOUR_RED}, {COLOUR_DARK_GREEN, COLOUR_GREEN}};
+
+		NWidgetCore *wi = this->GetWidget<NWidgetCore>(SSW_WIDGET_BUTTONS);
+		DrawFrameRect(wi->pos_x, y, wi->pos_x + wi->current_x - 1, y + 8,
+			_button_colour_table[!!value_future][_local_company == this->owner], value_future ? FR_LOWERED : FR_NONE);
+
+		this->DrawWidgetString(SSW_WIDGET_SETTINGS, y, str);
+		this->DrawBoolValue(y, value_current, false);
+		this->DrawBoolValue(y, value_future, true);
+		y += this->line_height;
+	}
+
+	/**
+	 * Should the text line given by the parameter be drawn on de screen? (depends on scrolling)
+	 * Parameter 'line' is passed by reference, and always incremented by one.
+	 * @param Line the line to draw or not to draw.
+	 * @return True if the line is to be drawn.
+	 */
+	inline bool ShouldDrawLine(uint &line)
+	{
+		return this->vscroll.IsVisible(line++);
+	}
+
+	/**
+	 * Handle a click on a boolean option.
+	 * @param type The vehicle type that was clicked on.
+	 * @param option Bitmask of sharing options (station/depot/tracks) to be changed.
+	 */
+	void HandleOptionClick(VehicleType type, uint8 option)
+	{
+		byte value = this->company->sharing_future.GetSharingOption(type) ^ option;
+		/* for trains, we don't want tracks to be disabled while stations or depots are enabled */
+		if (type == VEH_TRAIN && value != 0 && (value & SHARING_TRACK) == 0) {
+			if (option == SHARING_TRACK) {
+				/* tracks were just disabled, so clear all other bits as well */
+				value = 0;
+			} else {
+				/* stations or depots were just enabled, so enable tracks as well */
+				value |= SHARING_TRACK;
+			}
+		}
+		DoCommandP(0, MODIFY_SHARING_OPTION | (type << 8), value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+	}
+
+	/**
+	 * Handle a click on one of the fees.
+	 * @param type The vehicle type for which the fee is to be adjusted.
+	 * @param x The x-coordinate of the click, relative to the left edge of the button.
+	 * This is used to determine whether the left or right button was clicked.
+	 */
+	void HandleFeeClick(VehicleType type, int x)
+	{
+		if ((this->flags4 & WF_TIMEOUT_MASK) > WF_TIMEOUT_TRIGGER) {
+			_left_button_clicked = false;
+			return;
+		}
+		int half_button_width = this->GetWidget<NWidgetBase>(SSW_WIDGET_BUTTONS)->current_x / 2;
+
+		uint16 value = this->company->sharing_future.GetSharingFee(type);
+		uint16 new_value = value;
+		if (x < half_button_width && value > 0) {
+			/* left button */
+			this->clicked_row = type;
+			this->clicked_side = 1;
+			new_value = value - min(10, value);
+		} else if (x >= half_button_width && value < MAX_SHARING_FEE) {
+			/* right button */
+			this->clicked_row = type;
+			this->clicked_side = 2;
+			new_value = value + min(10, MAX_SHARING_FEE - value);
+		}
+		if (new_value != value) {
+			DoCommandP(0, MODIFY_SHARING_FEE | (type << 8), new_value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+			this->flags4 |= WF_TIMEOUT_BEGIN;
+			_left_button_clicked = false;
+		}
+	}
+
+	/**
+	 * Compute the total number of items (text lines) in the window
+	 */
+	void ComputeScrollCount()
+	{
+		byte num_scroll;
+		if (this->companies_tab) {
+			num_scroll = SSWL_COMPANY_FIRST;
+			Company *c;
+			FOR_ALL_COMPANIES(c) {
+				if (this->company != c) num_scroll++;
+			}
+		} else {
+			num_scroll = SSWL_END;
+		}
+		if (this->company->sharing_delay > 0) {
+			num_scroll += 2; // 1 blank line and 1 line for the delay
+		}
+		this->vscroll.SetCount(num_scroll);
+	}
+
+	/**
+	 * Compute the number of items (text lines) that fit in the window
+	 */
+	void ComputeScrollCapacity()
+	{
+		this->vscroll.SetCapacity((this->GetWidget<NWidgetBase>(SSW_WIDGET_PANEL)->current_y - 2) / this->line_height);
+		/* Make sure the size is exactly correct */
+		assert(this->GetWidget<NWidgetBase>(SSW_WIDGET_PANEL)->current_y == (this->vscroll.GetCapacity() * this->line_height + 2));
+	}
+
+public:
+	/** Constructor */
+	SharingSettingsWindow(const WindowDesc *desc, WindowNumber number) : Window()
+	{
+		this->company = Company::GetIfValid(number);
+		assert(this->company != NULL);
+
+		this->InitNested(desc, number);
+
+		/* Set this->owner now, because otherwise InitNested overrides this value
+		 * This means we cannot use this variable for anything (including size computations!) in the initialization stage */
+		this->owner = (Owner)number;
+
+		this->ComputeScrollCount();
+		this->ComputeScrollCapacity();
+
+		this->DisableWidget(SSW_WIDGET_OPTIONS);
+	}
+
+	virtual void OnPaint()
+	{
+		this->DrawWidgets();
+
+		CompanySharingSettingsEntry *future = &this->company->sharing_future;
+		CompanySharingSettingsEntry *current = &this->company->sharing_current;
+
+		uint y = this->GetWidget<NWidgetBase>(SSW_WIDGET_PANEL)->pos_y + 1;
+		uint current_line = SSWL_HEADERS;
+
+		/* draw text headers */
+		if (this->ShouldDrawLine(current_line)) {
+			this->DrawWidgetString(SSW_WIDGET_CURRENT, y, STR_SHARING_CURRENT);
+			this->DrawWidgetString(SSW_WIDGET_FUTURE,  y, STR_SHARING_FUTURE);
+			y += this->line_height;
+		}
+
+		if (this->companies_tab) {
+			Company *c;
+			FOR_ALL_COMPANIES(c) {
+				if (this->company == c) continue; //Skip our own company, as it would be silly to allow / disallow yourself.
+				if (this->ShouldDrawLine(current_line)) {
+					DrawCompanyIcon(c->index, this->GetWidget<NWidgetBase>(SSW_WIDGET_ICONS)->pos_x + 2, y + 1);
+					SetDParam(0, c->index);
+					this->DrawSharingOption(STR_SHARING_SETTING_COMPANY, y, current->IsCompanyAllowed(c->index), future->IsCompanyAllowed(c->index));
+				}
+			}
+			if (current_line == SSWL_COMPANY_FIRST) {
+				/* it seems there are no companies at all, apart from ourselves */
+				if (this->ShouldDrawLine(current_line)) {
+					this->DrawWidgetString(SSW_WIDGET_SETTINGS, y, STR_SHARING_SETTING_NO_COMPANIES);
+					return; //don't draw the sharing delay
+				}
+			} else if (this->ShouldDrawLine(current_line)) {
+				/* Blank line */
+				y += this->line_height;
+			}
+		} else {
+			/* draw text and buttons for all vehicle types */
+			for (VehicleType type = VEH_TRAIN; type < NUM_SHARING_VEHTYPES; type++) {
+				SubSprite sub = {0, (this->vscroll.GetPosition() - current_line) * this->line_height, INT32_MAX, (this->vscroll.GetPosition() + this->vscroll.GetCapacity() - current_line) * this->line_height - 1};
+				DrawSprite(SPR_IMG_TRAINLIST + type, PAL_NONE, this->GetWidget<NWidgetBase>(SSW_WIDGET_ICONS)->pos_x, y, &sub);
+
+				/* Some special lines for trains */
+				if (type == VEH_TRAIN) {
+					if (this->ShouldDrawLine(current_line)) {
+						this->DrawSharingOption(STR_SHARING_SETTING_TRACK, y,
+							(current->GetSharingOption(VEH_TRAIN) & SHARING_TRACK) != 0,
+							(future->GetSharingOption(VEH_TRAIN) & SHARING_TRACK) != 0);
+					}
+					if (this->ShouldDrawLine(current_line)) {
+						this->DrawSharingOption(STR_SHARING_SETTING_DEPOT, y,
+							(current->GetSharingOption(VEH_TRAIN) & SHARING_DEPOT) != 0,
+							(future->GetSharingOption(VEH_TRAIN) & SHARING_DEPOT) != 0);
+					}
+				}
+
+				/** String lookup table for station names ('Station', 'road stop' etc) */
+				static const StringID sharing_station_string[] = {
+					STR_SHARING_SETTING_STATION,
+					STR_SHARING_SETTING_ROADSTOP,
+					STR_SHARING_SETTING_DOCK,
+					STR_SHARING_SETTING_AIRPORT,
+				};
+
+				if (this->ShouldDrawLine(current_line)) {
+					this->DrawSharingOption(sharing_station_string[type], y,
+						(current->GetSharingOption(type) & SHARING_STATION) != 0,
+						(future->GetSharingOption(type) & SHARING_STATION) != 0);
+				}
+
+				/* sharing fee */
+				if (this->ShouldDrawLine(current_line)) {
+					/* Draw arrow buttons in the correct state */
+					bool l_clickable = this->owner == _local_company && future->GetSharingFee(type) > 0;
+					bool r_clickable = this->owner == _local_company && future->GetSharingFee(type) < MAX_SHARING_FEE;
+					byte arrow_clicked = (type == this->clicked_row) ? this->clicked_side : 0;
+					if ((arrow_clicked == 1 && !l_clickable) || (arrow_clicked == 2 && !r_clickable)) {
+						arrow_clicked = 0;
+					}
+					DrawArrowButtons(this->GetWidget<NWidgetBase>(SSW_WIDGET_BUTTONS)->pos_x, y, COLOUR_YELLOW, arrow_clicked, l_clickable, r_clickable);
+
+					/* Draw the fee strings */
+					this->DrawWidgetString(SSW_WIDGET_SETTINGS, y, type == VEH_TRAIN ? STR_SHARING_SETTING_MONTHLY_TOLL : STR_SHARING_SETTING_FEE, TC_BLACK);
+					SetDParam(0, current->GetSharingFee(type));
+					this->DrawWidgetString(SSW_WIDGET_CURRENT,  y, STR_JUST_CURRENCY, TC_ORANGE);
+					SetDParam(0, future->GetSharingFee(type));
+					this->DrawWidgetString(SSW_WIDGET_FUTURE,   y, STR_JUST_CURRENCY, TC_ORANGE);
+					y += this->line_height;
+				}
+				/* Add some spacing */
+				if (this->ShouldDrawLine(current_line)) y += this->line_height;
+			}
+		}
+
+		/* draw sharing delay */
+		if (this->ShouldDrawLine(current_line) && this->company->sharing_delay > 0) {
+			this->DrawWidgetString(SSW_WIDGET_SETTINGS, y, STR_SHARING_CHANGES_TAKE_EFFECT);
+			SetDParam(0, this->company->sharing_delay);
+			this->DrawWidgetString(SSW_WIDGET_CURRENT, y, STR_SHARING_TAKE_EFFECT_MONTHS);
+		}
+	}
+
+	virtual void SetStringParameters(int widget) const
+	{
+		if (widget == SSW_WIDGET_CAPTION) SetDParam(0, this->company->index);
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *resize)
+	{
+		Dimension d = {0, 0};
+		switch (widget) {
+			case SSW_WIDGET_ICONS:
+				for (VehicleType type = VEH_TRAIN; type < NUM_SHARING_VEHTYPES; type++) {
+					d = maxdim(d, GetSpriteSize(SPR_IMG_TRAINLIST + type));
+				}
+				break;
+			case SSW_WIDGET_SETTINGS:
+				this->line_height = max(11, FONT_HEIGHT_NORMAL + 1); //minimal line height is 11
+				resize->height = this->line_height;
+
+				d = maxdim(GetStringBoundingBox(STR_SHARING_SETTING_MONTHLY_TOLL), GetStringBoundingBox(STR_SHARING_SETTING_FEE));
+				d = maxdim(d, GetStringBoundingBox(STR_SHARING_SETTING_NO_COMPANIES));
+				d = maxdim(d, GetStringBoundingBox(STR_SHARING_CHANGES_TAKE_EFFECT));
+				for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+					if (Company::IsValidID(c) && c != this->company->index) {
+						SetDParam(0, c);
+						d = maxdim(d, GetStringBoundingBox(STR_SHARING_SETTING_COMPANY));
+					}
+				}
+				/* make the minimal height a multiple of line_height ( + 2 pixels of spacing) */
+				{
+					uint num_lines = (size->height - 1) / this->line_height + 1; //round upwards
+					d.height = num_lines * this->line_height + 2;
+				}
+				break;
+			case SSW_WIDGET_CURRENT:
+			case SSW_WIDGET_FUTURE:
+				d = maxdim(GetStringBoundingBox(STR_SHARING_VALUE_ALLOWED), GetStringBoundingBox(STR_SHARING_VALUE_NOT_ALLOWED));
+				SetDParam(0, MAX_SHARING_FEE);
+				d = maxdim(d, GetStringBoundingBox(STR_JUST_CURRENCY));
+				d = maxdim(d, GetStringBoundingBox((widget == SSW_WIDGET_CURRENT) ? STR_SHARING_CURRENT : STR_SHARING_FUTURE));
+				break;
+			default: return;
+		}
+		*size = maxdim(*size, d);
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		if (widget == SSW_WIDGET_OPTIONS || widget == SSW_WIDGET_COMPANIES) {
+			this->companies_tab = (widget == SSW_WIDGET_COMPANIES);
+			this->SetWidgetDisabledState(SSW_WIDGET_OPTIONS, !this->companies_tab);
+			this->SetWidgetDisabledState(SSW_WIDGET_COMPANIES, this->companies_tab);
+			this->ComputeScrollCount();
+			this->SetDirty();
+			return;
+		}
+		if (widget != SSW_WIDGET_BUTTONS && widget != SSW_WIDGET_FUTURE) return;
+		if (this->owner != _local_company) return;
+
+		int y = pt.y - this->GetWidget<NWidgetBase>(SSW_WIDGET_BUTTONS)->pos_y - 1;
+		/* don't allow clicking on the bottommost or topmost pixel of a line */
+		if (y <= 0 || y % this->line_height == 0 || y % this->line_height == this->line_height - 1) return;
+		int line = (y / this->line_height) + this->vscroll.GetPosition();
+
+		if (widget == SSW_WIDGET_FUTURE) {
+			/* Possibly clicked a fee, if that is the case, show a query string window. */
+			switch (line) {
+				case SSWL_TRAIN_FEE: this->current_query_type = VEH_TRAIN;    break;
+				case SSWL_ROAD_FEE:  this->current_query_type = VEH_ROAD;     break;
+				case SSWL_SHIP_FEE:  this->current_query_type = VEH_SHIP;     break;
+				case SSWL_PLANE_FEE: this->current_query_type = VEH_AIRCRAFT; break;
+				default: return;
+			}
+			SetDParam(0, this->company->sharing_future.GetSharingFee(this->current_query_type) * _currency->rate);
+			ShowQueryString(STR_JUST_INT, STR_SHARING_CHANGE_FEE_CAPTION, 10, 0, this, CS_NUMERAL, QSF_NONE);
+		} else if (this->companies_tab) { //else: SSW_WIDGET_BUTTONS
+			line -=  SSWL_COMPANY_FIRST;
+			/* Find out which company button we clicked on */
+			Company *c;
+			FOR_ALL_COMPANIES(c) {
+				if (c == this->company) continue;
+				if (line-- == 0) {
+					DoCommandP(0, MODIFY_SHARING_COMPANIES, this->company->sharing_future.allowed_companies ^ (1 << c->index), CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+					break;
+				}
+			}
+		} else {
+			int x = pt.x - this->GetWidget<NWidgetBase>(SSW_WIDGET_BUTTONS)->pos_x;
+			switch (line) {
+				case SSWL_TRAIN_TRACK:   this->HandleOptionClick(VEH_TRAIN, SHARING_TRACK); return;
+				case SSWL_TRAIN_DEPOT:   this->HandleOptionClick(VEH_TRAIN, SHARING_DEPOT); return;
+				case SSWL_TRAIN_STATION: this->HandleOptionClick(VEH_TRAIN, SHARING_STATION); return;
+				case SSWL_TRAIN_FEE:     this->HandleFeeClick(VEH_TRAIN, x); return;
+				case SSWL_ROAD_ROADSTOP: this->HandleOptionClick(VEH_ROAD, SHARING_STATION | SHARING_DEPOT); return;
+				case SSWL_ROAD_FEE:      this->HandleFeeClick(VEH_ROAD, x); return;
+				case SSWL_SHIP_DOCK:     this->HandleOptionClick(VEH_SHIP, SHARING_STATION | SHARING_DEPOT); return;
+				case SSWL_SHIP_FEE:      this->HandleFeeClick(VEH_SHIP, x); return;
+				case SSWL_PLANE_AIRPORT: this->HandleOptionClick(VEH_AIRCRAFT, SHARING_STATION | SHARING_DEPOT); return;
+				case SSWL_PLANE_FEE:     this->HandleFeeClick(VEH_AIRCRAFT, x); return;
+				default: return;
+			}
+		}
+	}
+
+	virtual void OnInvalidateData(int data = 0)
+	{
+		this->ComputeScrollCount();
+	}
+
+	virtual void OnResize()
+	{
+		this->ComputeScrollCapacity();
+	}
+
+	virtual void OnQueryTextFinished(char *str)
+	{
+		if (StrEmpty(str)) return;
+		int32 value = atoi(str);
+		value /= _currency->rate;
+		value = Clamp(value, 0, MAX_SHARING_FEE);
+		DoCommandP(0, MODIFY_SHARING_FEE | (this->current_query_type << 8), value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+	}
+
+	virtual void OnTimeout()
+	{
+		this->clicked_row = 0;
+		this->clicked_side = 0;
+		this->SetDirty();
+	}
+};
+
+static const NWidgetPart _nested_sharing_settings_widgets[] = {
+	NWidget(NWID_HORIZONTAL), // Window header
+		NWidget(WWT_CLOSEBOX, COLOUR_GREY, SSW_WIDGET_CLOSEBOX), SetFill(false, true),
+		NWidget(WWT_CAPTION, COLOUR_GREY, SSW_WIDGET_CAPTION), SetDataTip(STR_SHARING_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
+		NWidget(WWT_STICKYBOX, COLOUR_GREY, SSW_WIDGET_STICKY), SetFill(false, true),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_PANEL, COLOUR_GREY, SSW_WIDGET_PANEL), SetDataTip(0x0, STR_SHARING_PANEL_TOOLTIP), SetFill(true, true),
+			NWidget(NWID_HORIZONTAL), SetPIP(2, 2, 2),
+				/* Empty widgets to position the text columns */
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_ICONS),    SetMinimalSize(20,  90), SetResize(0, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_SETTINGS), SetMinimalSize(160, 90), SetResize(1, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_CURRENT),  SetMinimalSize(80,  90), SetResize(1, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_BUTTONS),  SetMinimalSize(20,  90), SetResize(0, 1), SetPadding(0, 2, 0, 2),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_FUTURE),   SetMinimalSize(80,  90), SetResize(1, 1),
+			EndContainer(),
+		EndContainer(),
+		NWidget(WWT_SCROLLBAR, COLOUR_GREY, SSW_WIDGET_SCROLL),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_WIDGET_OPTIONS),   SetMinimalSize(0, 12), SetResize(1, 0),
+							SetDataTip(STR_SHARING_OPTIONS, STR_SHARING_OPTIONS_TOOLTIP), SetFill(true, false),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_WIDGET_COMPANIES), SetMinimalSize(0, 12), SetResize(1, 0),
+							SetDataTip(STR_SHARING_COMPANIES, STR_SHARING_COMPANIES_TOOLTIP), SetFill(true, false),
+		NWidget(WWT_RESIZEBOX,  COLOUR_GREY, SSW_WIDGET_RESIZE), SetFill(false, true),
+	EndContainer(),
+};
+
+static const WindowDesc _sharing_settings_desc(
+	WDP_AUTO, WDP_AUTO, 388, 116, 388, 215,
+	WC_SHARING_OPTIONS, WC_COMPANY,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS | WDF_STICKY_BUTTON | WDF_RESIZABLE,
+	NULL, _nested_sharing_settings_widgets, lengthof(_nested_sharing_settings_widgets)
+);
+
+/**
+ * Show the sharing window of a company.
+ * @param company The company whose window to show.
+ */
+static void ShowCompanySharingSettings(CompanyID company)
+{
+	if ((_settings_game.sharing.sharing_mode == SHARING_INDIVIDUAL) && Company::IsValidID(company)) {
+		AllocateWindowDescFront<SharingSettingsWindow>(&_sharing_settings_desc, company);
+	}
+}
Index: src/news_gui.cpp
===================================================================
--- src/news_gui.cpp	(revision 17973)
+++ src/news_gui.cpp	(working copy)
@@ -238,6 +238,7 @@
 	{ NT_COMPANY_INFO,     NF_NONE,                        &_company_news_desc }, ///< NS_COMPANY_MERGER
 	{ NT_COMPANY_INFO,     NF_NONE,                        &_company_news_desc }, ///< NS_COMPANY_BANKRUPT
 	{ NT_COMPANY_INFO,     NF_NONE,                        &_company_news_desc }, ///< NS_COMPANY_NEW
+	{ NT_COMPANY_INFO,     NF_NONE,                        &_company_news_desc }, ///< NS_COMPANY_SHARING
 	{ NT_INDUSTRY_OPEN,    (NF_NO_TRANSPARENT | NF_SHADE), &_thin_news_desc    }, ///< NS_INDUSTRY_OPEN
 	{ NT_INDUSTRY_CLOSE,   (NF_NO_TRANSPARENT | NF_SHADE), &_thin_news_desc    }, ///< NS_INDUSTRY_CLOSE
 	{ NT_ECONOMY,          NF_NONE,                        &_normal_news_desc  }, ///< NS_ECONOMY
@@ -311,6 +312,10 @@
 				this->GetWidget<NWidgetCore>(NTW_TITLE)->widget_data = STR_NEWS_COMPANY_LAUNCH_TITLE;
 				break;
 
+			case NS_COMPANY_SHARING:
+				this->GetWidget<NWidgetCore>(NTW_TITLE)->widget_data = STR_NEWS_SHARING_TITLE;
+				break;
+
 			default:
 				break;
 		}
@@ -526,6 +531,12 @@
 				SetDParam(1, this->ni->params[3]);
 				return STR_NEWS_COMPANY_LAUNCH_DESCRIPTION;
 
+			case NS_COMPANY_SHARING:
+				SetDParam(0, ni->params[2]);
+				SetDParam(1, ni->params[3]);
+				return ni->params[1];
+				break;
+
 			default:
 				NOT_REACHED();
 		}
Index: src/vehicle_gui.cpp
===================================================================
--- src/vehicle_gui.cpp	(revision 17973)
+++ src/vehicle_gui.cpp	(working copy)
@@ -39,6 +39,7 @@
 #include "vehiclelist.h"
 #include "articulated_vehicles.h"
 #include "cargotype.h"
+#include "infrastructure_func.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -1812,6 +1813,7 @@
 	{
 		const Vehicle *v = Vehicle::Get(this->window_number);
 		bool is_localcompany = v->owner == _local_company;
+		bool can_control = IsVehicleControlAllowed(v);
 		bool refitable_and_stopped_in_depot = IsVehicleRefitable(v);
 
 		this->SetWidgetDisabledState(VVW_WIDGET_GOTO_DEPOT, !is_localcompany);
@@ -1819,8 +1821,8 @@
 		this->SetWidgetDisabledState(VVW_WIDGET_CLONE_VEH, !is_localcompany);
 
 		if (v->type == VEH_TRAIN) {
-			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_localcompany);
-			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_localcompany);
+			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !can_control);
+			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !can_control);
 		}
 
 		this->DrawWidgets();
Index: src/saveload/saveload.cpp
===================================================================
--- src/saveload/saveload.cpp	(revision 17973)
+++ src/saveload/saveload.cpp	(working copy)
@@ -47,8 +47,9 @@
 
 #include "saveload_internal.h"
 
-extern const uint16 SAVEGAME_VERSION = 127;
+extern const uint16 SAVEGAME_VERSION = SL_IS;
 
+
 SavegameType _savegame_type; ///< type of savegame we are loading
 
 uint32 _ttdp_version;     ///< version of TTDP savegame (if applicable)
